package x36paa_batoh;

import javax.swing.*;
import layout.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Main extends JFrame implements WindowListener, ActionListener {

  SourceTable sourceTable=new SourceTable();
  Graphs graphs=new Graphs();
  JButton buttons[]={
                    new JButton("Hrubou silou"),
                    new JButton("Heurestikou podle cena/hmotnost"),
                    new JButton("Prove men"),
                    new JButton("Zm testovan data heurestikou podle cena/hmotnost"),
                    new JButton("Heurestika: cena/hmotnost")

  };

  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch (Exception e) {
      e.printStackTrace();
    }
    new Main();
  }

  public JPanel getButtonsPanel() {
    double size[][]=new double[2][];
    size[0]=new double[buttons.length*2];
    for (int i=0;i<size[0].length;i++) {
      size[0][i]=((i&1)==0)?5:TableLayout.PREFERRED;
    }
    size[0][0]=TableLayout.FILL;
    size[1]=new double[] {TableLayout.FILL};
    JPanel out=new JPanel(new TableLayout(size));
    for (int i=0;i<buttons.length;i++) {
      out.add(buttons[i], (1+i*2)+",0,F,F");
      buttons[i].addActionListener(this);
    }
    return out;
  }

  public void actionPerformed(ActionEvent event) {
    MethodsResult mr=null;
    if (event.getSource()==buttons[0]) { //brutal force
      mr=new BrutalForce(sourceTable.getData(),sourceTable.getMaxWeigth());
    } else if (event.getSource()==buttons[1]) { // heurestika cena/hmotnost
      mr=new Heurestic1(sourceTable.getData(),sourceTable.getMaxWeigth());
    } else if (event.getSource()==buttons[2]) { // mereni - graf
      graphs.setMeasure(new Measure1());
    } else if (event.getSource()==buttons[3]) { // mereni - soubory
      graphs.setMeasure(new Measure2());
    } else if (event.getSource()==buttons[4]) { // vyber heurestiky
      Heurestic1.sortBy((Heurestic1.getSortBy()+1) % Heurestic1.COUNT_OF_HEURESTICS);
      String name="";
      switch (Heurestic1.getSortBy()) {
        case Heurestic1.PRICE:
          name="klesajc cena";
          break;
        case Heurestic1.WEIGTH:
          name="rostouc hmotnost";
          break;
        case Heurestic1.PRICE_WEIGTH:
          name="cena/hmotnost";
          break;
      }
      buttons[4].setText("Heurestika: "+name);
    }
    if (mr==null) return;
    JDialog jDialog=new JDialog(this,"Vsledek",true);
    JPanel jPanel=new JPanel(new TableLayout(new double[][] {
                                             {TableLayout.FILL},
                                             {TableLayout.PREFERRED,5,TableLayout.PREFERRED,TableLayout.PREFERRED,5,TableLayout.PREFERRED,TableLayout.FILL,TableLayout.PREFERRED}
    }));
    jPanel.add(new JLabel("<html>Metoda : <b>" + mr.methodsName + "</b></html>"),"0,0,F,F");
    String content=null;
    for (int i=0; i<mr.output.length;i++) {
      if (mr.output[i]) {
        content=(content==null)?(String) mr.data[i][0]:content+", "+mr.data[i][0];
      }
    }
    if (content==null) content="Przdn";
    jPanel.add(new JLabel("<html>Obsah batohu : <b>" + content + "</b></html>"),"0,2,F,F");
    jPanel.add(new JLabel("<html>Cena, hmotnost : <b>" + mr.price + ", " + mr.weigth + "/" + mr.maxWeigth + "</b></html>"),"0,3,F,F");
    jPanel.add(new JLabel("<html>Doba vpotu : <b>" + mr.time + " ns</b></html>"),"0,5,F,F");
    JButton jButton=new JButton("OK");
    jButton.addActionListener(new ActionListener() {
                              public void actionPerformed(ActionEvent event) {
                                JButton jButton=(JButton) event.getSource();
                                JPanel jPanel=(JPanel) jButton.getParent();
                                JPanel jPanel2=(JPanel) jPanel.getParent();
                                JLayeredPane jLayeredPane=(JLayeredPane) jPanel2.getParent();
                                JRootPane jRootPane=(JRootPane) jLayeredPane.getParent();
                                JDialog jDialog=(JDialog) jRootPane.getParent();
                                jDialog.dispose();
                              }
    });
    jPanel.add(jButton,"0,7,R,F");
    jDialog.getContentPane().add(jPanel);
    jDialog.pack();
    jDialog.setLocationRelativeTo(null);
    jDialog.setVisible(true);
  }

  public Main() {
    super("Problm batohu");
    this.getContentPane().setLayout(new TableLayout(new double[][] {
        {0.5,0.5},
        {TableLayout.FILL,5,TableLayout.PREFERRED}
    }));
    this.add(sourceTable,"0,0,F,F");
    this.add(graphs,"1,0,F,F");
    this.add(getButtonsPanel(),"0,2,1,2");
    this.addWindowListener(this);
    this.pack();
    this.setLocationRelativeTo(null);
    this.setVisible(true);
  }

  public void windowOpened(WindowEvent e) {
  }

  public void windowClosing(WindowEvent e) {
    System.exit(0);
  }

  public void windowClosed(WindowEvent e) {
  }

  public void windowIconified(WindowEvent e) {
  }

  public void windowDeiconified(WindowEvent e) {
  }

  public void windowActivated(WindowEvent e) {
  }

  public void windowDeactivated(WindowEvent e) {
  }
}
